scala.io

# BufferedSource

#### class BufferedSource extends Source

This object provides convenience methods to create an iterable representation of a source file.

Source
  BufferedSource.scala

Linear Supertypes
Source, collection.Iterator[Char], collection.TraversableOnce[Char], GenTraversableOnce[Char], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BufferedSource
2. Source
3. Iterator
4. TraversableOnce
5. GenTraversableOnce
6. AnyRef
7. Any

Implicitly

1. by MonadOps
2. by any2stringadd
3. by any2stringfmt
4. by any2ArrowAssoc
5. by any2Ensuring
6. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BufferedSource(inputStream: InputStream)(implicit codec: Codec)

2. #### new BufferedSource(inputStream: InputStream, bufferSize: Int)(implicit codec: Codec)

### Type Members

1. #### class BufferedLineIterator extends AbstractIterator[String] with collection.Iterator[String]

2. #### class GroupedIterator[B >: A] extends AbstractIterator[Seq[B]] with Iterator[Seq[B]]

   A flexible iterator for transforming an `Iterator[A]` into an Iterator[Seq[A]], with configurable sequence size, step, and strategy for dealing with elements which don't fit evenly.

3. #### class LineIterator extends AbstractIterator[String] with Iterator[String]

   Definition Classes
     Source

4. #### class Positioner extends AnyRef

   Definition Classes
     Source

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BufferedSource to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ++(that: ⇒ collection.Iterator[Char]): collection.Iterator[Char]

   [use case] Concatenates this iterator with another.

   [use case]

   Concatenates this iterator with another.

   that

     the other iterator

   returns

     a new iterator that first yields the values produced by this iterator followed by the values produced by iterator `that`.

   Definition Classes
     Iterator
   Full Signature

   #### def ++[B >: Char](that: ⇒ GenTraversableOnce[B]): collection.Iterator[B]

6. #### def ->[B](y: B): (BufferedSource, B)

   Implicit information
     This member is added by an implicit conversion from BufferedSource to ArrowAssoc[BufferedSource] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

7. #### def /:[B](z: B)(op: (B, Char) ⇒ B): B

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite iterators.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

8. #### def :\[B](z: B)(op: (Char, B) ⇒ B): B

   Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite iterators.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

9. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

11. #### object NoPositioner extends Positioner

    Definition Classes
      Source

12. #### object RelaxedPosition extends Position

    A Position implementation which ignores errors in the positions.

13. #### object RelaxedPositioner extends Positioner

    Definition Classes
      Source

14. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this traversable or iterator to a string builder.

    Appends all elements of this traversable or iterator to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator without any separator string.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

15. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using a separator string.

    Appends all elements of this traversable or iterator to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator, separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

16. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings.

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, "LinkedList(", ", ", ")")
        res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

17. #### def aggregate[B](z: B)(seqop: (B, Char) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### def buffered: collection.BufferedIterator[Char]

    Creates a buffered iterator from this iterator.

    Creates a buffered iterator from this iterator.

    returns

      a buffered iterator producing the same values as this iterator.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

    See also

      scala.collection.BufferedIterator

20. #### def bufferedReader(): BufferedReader

21. #### def ch: Char

    Definition Classes
      Source

22. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

23. #### def close(): Unit

    The close() method closes the underlying resource.

    The close() method closes the underlying resource.

    Definition Classes
      Source

24. #### implicit val codec: Codec

25. #### def collect[B](pf: PartialFunction[Char, B]): collection.Iterator[B]

    Creates an iterator by transforming values produced by this iterator with a partial function, dropping those values for which the partial function is not defined.

    Creates an iterator by transforming values produced by this iterator with a partial function, dropping those values for which the partial function is not defined.

    pf

      the partial function which filters and maps the iterator.

    returns

      a new iterator which yields each value `x` produced by this iterator for which `pf` is defined the image `pf(x)`.

    Definition Classes
      Iterator
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `collect` has changed. The previous behavior can be reproduced with `toSeq`.

    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

26. #### def collectFirst[B](pf: PartialFunction[Char, B]): Option[B]

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

27. #### def contains(elem: Any): Boolean

    Tests whether this iterator contains a given value as an element.

    Tests whether this iterator contains a given value as an element.

    Note: may not terminate for infinite iterators.

    elem

      the element to test.

    returns

      `true` if this iterator produces some value that is is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

28. #### def copyToArray(xs: Array[Char], start: Int, len: Int): Unit

    [use case] Copies selected values produced by this iterator to an array.

    [use case]

    Copies selected values produced by this iterator to an array. Fills the given array `xs` starting at index `start` with at most `len` values produced by this iterator. Copying will stop once either the end of the current iterator is reached, or the end of the array is reached, or `len` elements have been copied.

    Note: will not terminate for infinite iterators.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B], start: Int, len: Int): Unit

29. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this traversable or iterator to an array.

    [use case]

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    Note: will not terminate for infinite iterators.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B]): Unit

30. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this traversable or iterator to an array.

    [use case]

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator, beginning at index `start`. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    Note: will not terminate for infinite iterators.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B], start: Int): Unit

31. #### def copyToBuffer[B >: Char](dest: Buffer[B]): Unit

    Copies all elements of this traversable or iterator to a buffer.

    Copies all elements of this traversable or iterator to a buffer.

    Note: will not terminate for infinite iterators.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

32. #### def corresponds[B](that: GenTraversableOnce[B])(p: (Char, B) ⇒ Boolean): Boolean

    Tests whether every element of this iterator relates to the corresponding element of another collection by satisfying a test predicate.

    Tests whether every element of this iterator relates to the corresponding element of another collection by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other collection

    p

      the test predicate, which relates elements from both collections

    returns

      `true` if both collections have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this iterator and `y` of `that`, otherwise `false`

    Definition Classes
      Iterator

33. #### def count(p: (Char) ⇒ Boolean): Int

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

34. #### var descr: String

    description of this source, default empty

    description of this source, default empty

    Definition Classes
      Source

35. #### def drop(n: Int): collection.Iterator[Char]

    Advances this iterator past the first n elements, or the length of the iterator, whichever is smaller.

    Advances this iterator past the first n elements, or the length of the iterator, whichever is smaller.

    n

      the number of elements to drop

    returns

      an iterator which produces all values of the current iterator, except it omits the first `n` values.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

36. #### def dropWhile(p: (Char) ⇒ Boolean): collection.Iterator[Char]

    Skips longest sequence of elements of this iterator which satisfy given predicate `p`, and returns an iterator of the remaining elements.

    Skips longest sequence of elements of this iterator which satisfy given predicate `p`, and returns an iterator of the remaining elements.

    p

      the predicate used to skip elements.

    returns

      an iterator consisting of the remaining elements

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

37. #### def duplicate: (collection.Iterator[Char], collection.Iterator[Char])

    Creates two new iterators that both iterate over the same elements as this iterator (in the same order).

    Creates two new iterators that both iterate over the same elements as this iterator (in the same order). The duplicate iterators are considered equal if they are positioned at the same element.

    Given that most methods on iterators will make the original iterator unfit for further use, this methods provides a reliable way of calling multiple such methods on an iterator.

    returns

      a pair of iterators

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterators that were returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterators as well.

      ,

      The implementation may allocate temporary storage for elements iterated by one iterator but not yet by the other.

38. #### def ensuring(cond: (BufferedSource) ⇒ Boolean, msg: ⇒ Any): BufferedSource

    Implicit information
      This member is added by an implicit conversion from BufferedSource to Ensuring[BufferedSource] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

39. #### def ensuring(cond: (BufferedSource) ⇒ Boolean): BufferedSource

    Implicit information
      This member is added by an implicit conversion from BufferedSource to Ensuring[BufferedSource] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

40. #### def ensuring(cond: Boolean, msg: ⇒ Any): BufferedSource

    Implicit information
      This member is added by an implicit conversion from BufferedSource to Ensuring[BufferedSource] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

41. #### def ensuring(cond: Boolean): BufferedSource

    Implicit information
      This member is added by an implicit conversion from BufferedSource to Ensuring[BufferedSource] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

42. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

43. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

44. #### def exists(p: (Char) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the values produced by this iterator.

    Tests whether a predicate holds for some of the values produced by this iterator.

    Note: may not terminate for infinite iterators.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the values produced by this iterator, otherwise `false`.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

45. #### def filter(p: (Char) ⇒ Boolean): collection.Iterator[Char]

    Returns an iterator over all the elements of this iterator that satisfy the predicate `p`.

    Returns an iterator over all the elements of this iterator that satisfy the predicate `p`. The order of the elements is preserved.

    p

      the predicate used to test values.

    returns

      an iterator which produces those values of this iterator which satisfy the predicate `p`.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

46. #### def filterNot(p: (Char) ⇒ Boolean): collection.Iterator[Char]

    Creates an iterator over all the elements of this iterator which do not satisfy a predicate p.

    Creates an iterator over all the elements of this iterator which do not satisfy a predicate p.

    p

      the predicate used to test values.

    returns

      an iterator which produces those values of this iterator which do not satisfy the predicate `p`.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

47. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

48. #### def find(p: (Char) ⇒ Boolean): Option[Char]

    Finds the first value produced by the iterator satisfying a predicate, if any.

    Finds the first value produced by the iterator satisfying a predicate, if any.

    Note: may not terminate for infinite iterators.

    p

      the predicate used to test values.

    returns

      an option value containing the first value produced by the iterator that satisfies predicate `p`, or `None` if none exists.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

49. #### def flatMap[B](f: (Char) ⇒ GenTraversableOnce[B]): collection.Iterator[B]

    Creates a new iterator by applying a function to all values produced by this iterator and concatenating the results.

    Creates a new iterator by applying a function to all values produced by this iterator and concatenating the results.

    f

      the function to apply on each element.

    returns

      the iterator resulting from applying the given iterator-valued function `f` to each value produced by this iterator and concatenating the results.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

50. #### def fold[A1 >: Char](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

51. #### def foldLeft[B](z: B)(op: (B, Char) ⇒ B): B

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

52. #### def foldRight[B](z: B)(op: (Char, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

53. #### def forall(p: (Char) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all values produced by this iterator.

    Tests whether a predicate holds for all values produced by this iterator.

    Note: may not terminate for infinite iterators.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all values produced by this iterator, otherwise `false`.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

54. #### def foreach(f: (Char) ⇒ Unit): Unit

    [use case] Applies a function `f` to all values produced by this iterator.

    [use case]

    Applies a function `f` to all values produced by this iterator.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def foreach[U](f: (Char) ⇒ U): Unit

55. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from BufferedSource to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

56. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

57. #### def getLines(): collection.Iterator[String]

    Returns an iterator who returns lines (NOT including newline character(s)).

    Returns an iterator who returns lines (NOT including newline character(s)). It will treat any of \r\n, \r, or \n as a line separator (longest match) - if you need more refined behavior you can subclass Source#LineIterator directly.

    Definition Classes
      BufferedSource → Source

58. #### def grouped[B >: Char](size: Int): GroupedIterator[B]

    Returns an iterator which groups this iterator into fixed size blocks.

    Returns an iterator which groups this iterator into fixed size blocks. Example usages:

        // Returns List(List(1, 2, 3), List(4, 5, 6), List(7)))
        (1 to 7).iterator grouped 3 toList
        // Returns List(List(1, 2, 3), List(4, 5, 6))
        (1 to 7).iterator grouped 3 withPartial false toList
        // Returns List(List(1, 2, 3), List(4, 5, 6), List(7, 20, 25)
        // Illustrating that withPadding's argument is by-name.
        val it2 = Iterator.iterate(20)(_ + 5)
        (1 to 7).iterator grouped 3 withPadding it2.next toList

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

59. #### def hasDefiniteSize: Boolean

    Tests whether this Iterator has a known size.

    Tests whether this Iterator has a known size.

    returns

      `true` for empty Iterators, `false` otherwise.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Note

      Reuse: The iterator remains valid for further use whatever result is returned.

60. #### def hasNext: Boolean

    Returns `true` if this source has more characters.

    Returns `true` if this source has more characters.

    returns

      `true` if a subsequent call to `next` will yield an element, `false` otherwise.

    Definition Classes
      Source → Iterator

61. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

62. #### def indexOf[B >: Char](elem: B): Int

    Returns the index of the first occurrence of the specified object in this iterable object.

    Returns the index of the first occurrence of the specified object in this iterable object.

    Note: may not terminate for infinite iterators.

    elem

      element to search for.

    returns

      the index of the first occurrence of `elem` in the values produced by this iterator, or -1 if such an element does not exist until the end of the iterator is reached.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

63. #### def indexWhere(p: (Char) ⇒ Boolean): Int

    Returns the index of the first produced value satisfying a predicate, or -1.

    Returns the index of the first produced value satisfying a predicate, or -1.

    Note: may not terminate for infinite iterators.

    p

      the predicate to test values

    returns

      the index of the first produced value satisfying `p`, or -1 if such an element does not exist until the end of the iterator is reached.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

64. #### def isEmpty: Boolean

    Tests whether this iterator is empty.

    Tests whether this iterator is empty.

    returns

      `true` if hasNext is false, `false` otherwise.

    Definition Classes
      Iterator → TraversableOnce → GenTraversableOnce
    Note

      Reuse: The iterator remains valid for further use whatever result is returned.

65. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

66. #### def isTraversableAgain: Boolean

    Tests whether this Iterator can be repeatedly traversed.

    Tests whether this Iterator can be repeatedly traversed.

    returns

      `false`

    Definition Classes
      Iterator → GenTraversableOnce
    Note

      Reuse: The iterator remains valid for further use whatever result is returned.

67. #### lazy val iter: collection.Iterator[Char]

    Definition Classes
      BufferedSource → Source

68. #### def length: Int

    Returns the number of elements in this iterator.

    Returns the number of elements in this iterator.

    Note: will not terminate for infinite iterators.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on. Using it is undefined and subject to change.

69. #### def map[B](f: (Char) ⇒ B): collection.Iterator[B]

    Creates a new iterator that maps all produced values of this iterator to new values using a transformation function.

    Creates a new iterator that maps all produced values of this iterator to new values using a transformation function.

    f

      the transformation function

    returns

      a new iterator which transforms every value produced by this iterator by applying the function `f` to it.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

70. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def max[B >: Char](implicit cmp: Ordering[B]): Char

71. #### def maxBy[B](f: (Char) ⇒ B)(implicit cmp: Ordering[B]): Char

    Definition Classes
      TraversableOnce → GenTraversableOnce

72. #### def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this traversable or iterator

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def min[B >: Char](implicit cmp: Ordering[B]): Char

73. #### def minBy[B](f: (Char) ⇒ B)(implicit cmp: Ordering[B]): Char

    Definition Classes
      TraversableOnce → GenTraversableOnce

74. #### def mkString: String

    Displays all elements of this traversable or iterator in a string.

    Displays all elements of this traversable or iterator in a string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

75. #### def mkString(sep: String): String

    Displays all elements of this traversable or iterator in a string using a separator string.

    Displays all elements of this traversable or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

76. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

    Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this traversable or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

77. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

78. #### var nerrors: Int

    Definition Classes
      Source

79. #### def next(): Char

    Returns next character.

    Returns next character.

    returns

      the next element of this iterator, if `hasNext` is `true`, undefined behavior otherwise.

    Definition Classes
      Source → Iterator

80. #### def nonEmpty: Boolean

    Tests whether the traversable or iterator is not empty.

    Tests whether the traversable or iterator is not empty.

    returns

      `true` if the traversable or iterator contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

81. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

82. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

83. #### var nwarnings: Int

    Definition Classes
      Source

84. #### def padTo(len: Int, elem: Char): collection.Iterator[Char]

    [use case] Appends an element value to this iterator until a given target length is reached.

    [use case]

    Appends an element value to this iterator until a given target length is reached.

    len

      the target length

    elem

      the padding value

    returns

      a new iterator consisting of producing all values of this iterator, followed by the minimal number of occurrences of `elem` so that the number of produced values is at least `len`.

    Definition Classes
      Iterator
    Full Signature

    #### def padTo[A1 >: Char](len: Int, elem: A1): collection.Iterator[A1]

85. #### def partition(p: (Char) ⇒ Boolean): (collection.Iterator[Char], collection.Iterator[Char])

    Partitions this iterator in two iterators according to a predicate.

    Partitions this iterator in two iterators according to a predicate.

    p

      the predicate on which to partition

    returns

      a pair of iterators: the iterator that satisfies the predicate `p` and the iterator that does not. The relative order of the elements in the resulting iterators is the same as in the original iterator.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterators that were returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterators as well.

86. #### def patch[B >: Char](from: Int, patchElems: collection.Iterator[B], replaced: Int): collection.Iterator[B]

    Returns this iterator with patched values.

    Returns this iterator with patched values.

    from

      The start index from which to patch

    patchElems

      The iterator of patch values

    replaced

      The number of values in the original iterator that are replaced by the patch.

    Definition Classes
      Iterator
    Note

      Reuse: After calling this method, one should discard the iterator it was called on, as well as the one passed as a parameter, and use only the iterator that was returned. Using the old iterators is undefined, subject to change, and may result in changes to the new iterator as well.

87. #### def pos: Int

    Definition Classes
      Source

88. #### def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this traversable or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the traversable or iterator and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def product[B >: Char](implicit num: Numeric[B]): B

89. #### def reader(): InputStreamReader

90. #### def reduce[A1 >: Char](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this traversable or iterator using the specified associative binary operator.

    Reduces the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the traversable or iterator is nonempty.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this traversable or iterator is empty.

91. #### def reduceLeft[B >: Char](op: (B, Char) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator, going left to right.

    Applies a binary operator to all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right:

          op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this traversable or iterator is empty.

92. #### def reduceLeftOption[B >: Char](op: (B, Char) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

    Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this traversable or iterator is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

93. #### def reduceOption[A1 >: Char](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

94. #### def reduceRight[B >: Char](op: (Char, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator, going right to left.

    Applies a binary operator to all elements of this traversable or iterator, going right to left.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this traversable or iterator is empty.

95. #### def reduceRightOption[B >: Char](op: (Char, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

    Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

    Note: will not terminate for infinite iterators.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this traversable or iterator is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

96. #### def report(pos: Int, msg: String, out: PrintStream): Unit

    pos

      the source position (line/column)

    msg

      the error message to report

    out

      PrintStream to use

    Definition Classes
      Source

97. #### def reportError(pos: Int, msg: String, out: PrintStream = Console.err): Unit

    Reports an error message to the output stream `out`.

    Reports an error message to the output stream `out`.

    pos

      the source position (line/column)

    msg

      the error message to report

    out

      PrintStream to use (optional: defaults to `Console.err`)

    Definition Classes
      Source

98. #### def reportWarning(pos: Int, msg: String, out: PrintStream = Console.out): Unit

    pos

      the source position (line/column)

    msg

      the warning message to report

    out

      PrintStream to use (optional: defaults to `Console.out`)

    Definition Classes
      Source

99. #### def reset(): Source

    The reset() method creates a fresh copy of this Source.

    The reset() method creates a fresh copy of this Source.

    Definition Classes
      Source

100. #### def reversed: List[Char]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

101. #### def sameElements(that: collection.Iterator[_]): Boolean

     Tests if another iterator produces the same values as this one.

     Tests if another iterator produces the same values as this one.

     Note: will not terminate for infinite iterators.

     that

       the other iterator

     returns

       `true`, if both iterators produce the same elements in the same order, `false` otherwise.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, as well as the one passed as parameter. Using the old iterators is undefined and subject to change.

102. #### def scanLeft[B](z: B)(op: (B, Char) ⇒ B): collection.Iterator[B]

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite iterators.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     returns

       iterator with intermediate results

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

103. #### def scanRight[B](z: B)(op: (Char, B) ⇒ B): collection.Iterator[B]

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite iterators.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     returns

       iterator with intermediate results

     Definition Classes
       Iterator
     Example:

     1.     Iterator(1, 2, 3, 4).scanRight(0)(_ + _).toList == List(10, 9, 7, 4, 0)

     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

104. #### def seq: collection.Iterator[Char]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Iterator → TraversableOnce → GenTraversableOnce

105. #### def size: Int

     The size of this traversable or iterator.

     The size of this traversable or iterator.

     Note: will not terminate for infinite iterators.

     returns

       the number of elements in this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

106. #### def slice(from: Int, until: Int): collection.Iterator[Char]

     Creates an iterator returning an interval of the values produced by this iterator.

     Creates an iterator returning an interval of the values produced by this iterator.

     from

       the index of the first element in this iterator which forms part of the slice.

     until

       the index of the first element following the slice.

     returns

       an iterator which advances this iterator past the first `from` elements using `drop`, and then takes `until - from` elements, using `take`.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

107. #### def sliding[B >: Char](size: Int, step: Int = 1): GroupedIterator[B]

     Returns an iterator which presents a "sliding window" view of another iterator.

     Returns an iterator which presents a "sliding window" view of another iterator. The first argument is the window size, and the second is how far to advance the window on each iteration; defaults to `1`. Example usages:

         // Returns List(List(1, 2, 3), List(2, 3, 4), List(3, 4, 5))
         (1 to 5).iterator.sliding(3).toList
         // Returns List(List(1, 2, 3, 4), List(4, 5))
         (1 to 5).iterator.sliding(4, 3).toList
         // Returns List(List(1, 2, 3, 4))
         (1 to 5).iterator.sliding(4, 3).withPartial(false).toList
         // Returns List(List(1, 2, 3, 4), List(4, 5, 20, 25))
         // Illustrating that withPadding's argument is by-name.
         val it2 = Iterator.iterate(20)(_ + 5)
         (1 to 5).iterator.sliding(4, 3).withPadding(it2.next).toList

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

108. #### def span(p: (Char) ⇒ Boolean): (collection.Iterator[Char], collection.Iterator[Char])

     Splits this Iterator into a prefix/suffix pair according to a predicate.

     Splits this Iterator into a prefix/suffix pair according to a predicate.

     p

       the test predicate

     returns

       a pair of Iterators consisting of the longest prefix of this whose elements all satisfy `p`, and the rest of the Iterator.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterators that were returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterators as well.

109. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this traversable or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the traversable or iterator and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: Char](implicit num: Numeric[B]): B

110. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

111. #### def take(n: Int): collection.Iterator[Char]

     Selects first n values of this iterator.

     Selects first n values of this iterator.

     n

       the number of values to take

     returns

       an iterator producing only of the first `n` values of this iterator, or else the whole iterator, if it produces fewer than `n` values.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

112. #### def takeWhile(p: (Char) ⇒ Boolean): collection.Iterator[Char]

     Takes longest prefix of values produced by this iterator that satisfy a predicate.

     Takes longest prefix of values produced by this iterator that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       An iterator returning the values produced by this iterator, until this iterator produces a value that does not satisfy the predicate `p`.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

113. #### def to[Col[_]]: Col[A]

     [use case] Converts this traversable or iterator into another by copying all elements.

     [use case]

     Converts this traversable or iterator into another by copying all elements.

     Note: will not terminate for infinite iterators.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, Char, Col[Char]]): Col[Char]

114. #### def toArray: Array[A]

     [use case] Converts this traversable or iterator to an array.

     [use case]

     Converts this traversable or iterator to an array.

     Note: will not terminate for infinite iterators.

     returns

       an array containing all elements of this traversable or iterator. An `ClassTag` must be available for the element type of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: Char](implicit arg0: ClassTag[B]): Array[B]

115. #### def toBuffer[B >: Char]: Buffer[B]

     Converts this traversable or iterator to a mutable buffer.

     Converts this traversable or iterator to a mutable buffer.

     Note: will not terminate for infinite iterators.

     returns

       a buffer containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

116. #### def toIndexedSeq: collection.immutable.IndexedSeq[Char]

     Converts this traversable or iterator to an indexed sequence.

     Converts this traversable or iterator to an indexed sequence.

     Note: will not terminate for infinite iterators.

     returns

       an indexed sequence containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

117. #### def toIterable: collection.Iterable[Char]

     Converts this traversable or iterator to an iterable collection.

     Converts this traversable or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite iterators.

     returns

       an `Iterable` containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

118. #### def toIterator: collection.Iterator[Char]

     Returns an Iterator over the elements in this traversable or iterator.

     Returns an Iterator over the elements in this traversable or iterator. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite iterators.

     returns

       an Iterator containing all elements of this traversable or iterator.

     Definition Classes
       Iterator → GenTraversableOnce

119. #### def toList: List[Char]

     Converts this traversable or iterator to a list.

     Converts this traversable or iterator to a list.

     Note: will not terminate for infinite iterators.

     returns

       a list containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

120. #### def toMap[T, U]: Map[T, U]

     [use case] Converts this traversable or iterator to a map.

     [use case]

     Converts this traversable or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite iterators.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[Char, (T, U)]): Map[T, U]

121. #### def toSeq: collection.Seq[Char]

     Converts this traversable or iterator to a sequence.

     Converts this traversable or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite iterators.

     returns

       a sequence containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### def toSet[B >: Char]: Set[B]

     Converts this traversable or iterator to a set.

     Converts this traversable or iterator to a set.

     Note: will not terminate for infinite iterators.

     returns

       a set containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

123. #### def toStream: collection.immutable.Stream[Char]

     Converts this traversable or iterator to a stream.

     Converts this traversable or iterator to a stream.

     Note: will not terminate for infinite iterators.

     returns

       a stream containing all elements of this traversable or iterator.

     Definition Classes
       Iterator → GenTraversableOnce

124. #### def toString(): String

     Converts this iterator to a string.

     Converts this iterator to a string.

     returns

       `"empty iterator"` or `"non-empty iterator"`, depending on whether or not the iterator is empty.

     Definition Classes
       Iterator → AnyRef → Any
     Note

       Reuse: The iterator remains valid for further use whatever result is returned.

125. #### def toTraversable: collection.Traversable[Char]

     Converts this traversable or iterator to an unspecified Traversable.

     Converts this traversable or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite iterators.

     returns

       a Traversable containing all elements of this traversable or iterator.

     Definition Classes
       Iterator → TraversableOnce → GenTraversableOnce

126. #### def toVector: Vector[Char]

     Converts this traversable or iterator to a Vector.

     Converts this traversable or iterator to a Vector.

     Note: will not terminate for infinite iterators.

     returns

       a vector containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

128. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

129. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

130. #### def withClose(f: () ⇒ Unit): BufferedSource.this.type

     Definition Classes
       Source

131. #### def withDescription(text: String): BufferedSource.this.type

     Definition Classes
       Source

132. #### def withFilter(p: (Char) ⇒ Boolean): collection.Iterator[Char]

     Creates an iterator over all the elements of this iterator that satisfy the predicate `p`.

     Creates an iterator over all the elements of this iterator that satisfy the predicate `p`. The order of the elements is preserved.

     Note: `withFilter` is the same as `filter` on iterators. It exists so that for-expressions with filters work over iterators.

     p

       the predicate used to test values.

     returns

       an iterator which produces those values of this iterator which satisfy the predicate `p`.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

133. #### def withPositioning(pos: Positioner): BufferedSource.this.type

     Definition Classes
       Source

134. #### def withPositioning(on: Boolean): BufferedSource.this.type

     Change or disable the positioner.

     Change or disable the positioner.

     Definition Classes
       Source

135. #### def withReset(f: () ⇒ Source): BufferedSource.this.type

     Definition Classes
       Source

136. #### def zip[B](that: collection.Iterator[B]): collection.Iterator[(Char, B)]

     Creates an iterator formed from this iterator and another iterator by combining corresponding values in pairs.

     Creates an iterator formed from this iterator and another iterator by combining corresponding values in pairs. If one of the two iterators is longer than the other, its remaining elements are ignored.

     that

       The iterator providing the second half of each result pair

     returns

       a new iterator containing pairs consisting of corresponding elements of this iterator and `that`. The number of elements returned by the new iterator is the minimum of the number of elements returned by this iterator and `that`.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, as well as the one passed as a parameter, and use only the iterator that was returned. Using the old iterators is undefined, subject to change, and may result in changes to the new iterator as well.

137. #### def zipAll[B](that: collection.Iterator[B], thisElem: Char, thatElem: B): collection.Iterator[(Char, B)]

     [use case] Creates an iterator formed from this iterator and another iterator by combining corresponding elements in pairs.

     [use case]

     Creates an iterator formed from this iterator and another iterator by combining corresponding elements in pairs. If one of the two iterators is shorter than the other, placeholder elements are used to extend the shorter iterator to the length of the longer.

     that

       iterator `that` may have a different length as the self iterator.

     thisElem

       element `thisElem` is used to fill up the resulting iterator if the self iterator is shorter than `that`

     thatElem

       element `thatElem` is used to fill up the resulting iterator if `that` is shorter than the self iterator

     returns

       a new iterator containing pairs consisting of corresponding values of this iterator and `that`. The length of the returned iterator is the maximum of the lengths of this iterator and `that`. If this iterator is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this iterator, `thatElem` values are used to pad the result.

     Definition Classes
       Iterator
     Full Signature

     #### def zipAll[B, A1 >: Char, B1 >: B](that: collection.Iterator[B], thisElem: A1, thatElem: B1): collection.Iterator[(A1, B1)]

138. #### def zipWithIndex: collection.Iterator[(Char, Int)]

     Creates an iterator that pairs each element produced by this iterator with its index, counting from 0.

     Creates an iterator that pairs each element produced by this iterator with its index, counting from 0.

     returns

       a new iterator containing pairs consisting of corresponding elements of this iterator and their indices.

     Definition Classes
       Iterator
     Note

       Reuse: After calling this method, one should discard the iterator it was called on, and use only the iterator that was returned. Using the old iterator is undefined, subject to change, and may result in changes to the new iterator as well.

139. #### def →[B](y: B): (BufferedSource, B)

     Implicit information
       This member is added by an implicit conversion from BufferedSource to ArrowAssoc[BufferedSource] performed by method any2ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implict Value Members

1. #### def filter(p: (Char) ⇒ Boolean): collection.TraversableOnce[Char]

   Implicit information
     This member is added by an implicit conversion from BufferedSource to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (bufferedSource: MonadOps[Char]).filter(p)

   Definition Classes
     MonadOps

2. #### def flatMap[B](f: (Char) ⇒ GenTraversableOnce[B]): collection.TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from BufferedSource to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (bufferedSource: MonadOps[Char]).flatMap(f)

   Definition Classes
     MonadOps

3. #### def map[B](f: (Char) ⇒ B): collection.TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from BufferedSource to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (bufferedSource: MonadOps[Char]).map(f)

   Definition Classes
     MonadOps

4. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from BufferedSource to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (bufferedSource: StringAdd).self

   Definition Classes
     StringAdd

5. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from BufferedSource to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (bufferedSource: StringFormat).self

   Definition Classes
     StringFormat

6. #### def withFilter(p: (Char) ⇒ Boolean): collection.Iterator[Char]

   Implicit information
     This member is added by an implicit conversion from BufferedSource to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (bufferedSource: MonadOps[Char]).withFilter(p)

   Definition Classes
     MonadOps

### Deprecated Value Members

1. #### def /:\[A1 >: Char](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a /:\ 5)(_+_)
       b: Int = 15

   Definition Classes
     GenTraversableOnce
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use fold instead

2. #### def x: BufferedSource

   Implicit information
     This member is added by an implicit conversion from BufferedSource to ArrowAssoc[BufferedSource] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (bufferedSource: ArrowAssoc[BufferedSource]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

3. #### def x: BufferedSource

   Implicit information
     This member is added by an implicit conversion from BufferedSource to Ensuring[BufferedSource] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (bufferedSource: Ensuring[BufferedSource]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Source

### Inherited from collection.Iterator[Char]

### Inherited from collection.TraversableOnce[Char]

### Inherited from GenTraversableOnce[Char]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion MonadOps from BufferedSource to MonadOps[Char]

### Inherited by implicit conversion any2stringadd from BufferedSource to StringAdd

### Inherited by implicit conversion any2stringfmt from BufferedSource to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from BufferedSource to ArrowAssoc[BufferedSource]

### Inherited by implicit conversion any2Ensuring from BufferedSource to Ensuring[BufferedSource]

### Inherited by implicit conversion alternateImplicit from BufferedSource to ForceImplicitAmbiguity

### Ungrouped